
#ifndef __nanojit_LirHelper__
#define __nanojit_LirHelper__

#include "stdint.h"

inline unsigned char bitScanReverse(unsigned long * Index,  unsigned long Mask)
{
	if (0 == Mask)
	{
		return 0;
	}

	unsigned int v(Mask);            // 32-bit value to find the log2 of
	register unsigned long r; // result of log2(v) will go here
	register unsigned int shift;

	r =     (v > 0xFFFF) << 4; v >>= r;
	shift = (v > 0xFF  ) << 3; v >>= shift; r |= shift;
	shift = (v > 0xF   ) << 2; v >>= shift; r |= shift;
	shift = (v > 0x3   ) << 1; v >>= shift; r |= shift;
	r |= (v >> 1);

	*Index = r;
	return 1;
}

namespace avmplus
{
	inline unsigned int AvmCountBitSet(uint32_t a_iValue)
	{
		unsigned int v = a_iValue; // count bits set in this (32-bit value)
		unsigned int c; // store the total here
		v = v - ((v >> 1) & 0x55555555);                    // reuse input as temporary
		v = (v & 0x33333333) + ((v >> 2) & 0x33333333);     // temp
		c = ((v + (v >> 4) & 0xF0F0F0F) * 0x1010101) >> 24; // count

		return c;
	}

	inline unsigned int AvmCountLeadingZeros(uint32_t a_iValue)
	{
		unsigned long iIndex = 0;
		if (bitScanReverse(&iIndex, a_iValue))
		{
			return iIndex;
		}

		return 32;
	}
}

#endif // __nanojit_LirHelper__

